// automatically generated by the FlatBuffers compiler, do not modify

package Serialization;

import java.nio.*;
import java.lang.*;
import java.util.*;
import com.google.flatbuffers.*;

@SuppressWarnings("unused")
public final class PortModel extends Table {
  public static void ValidateVersion() { Constants.FLATBUFFERS_1_12_0(); }
  public static PortModel getRootAsPortModel(ByteBuffer _bb) { return getRootAsPortModel(_bb, new PortModel()); }
  public static PortModel getRootAsPortModel(ByteBuffer _bb, PortModel obj) { _bb.order(ByteOrder.LITTLE_ENDIAN); return (obj.__assign(_bb.getInt(_bb.position()) + _bb.position(), _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __reset(_i, _bb); }
  public PortModel __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public String portName() { int o = __offset(4); return o != 0 ? __string(o + bb_pos) : null; }
  public ByteBuffer portNameAsByteBuffer() { return __vector_as_bytebuffer(4, 1); }
  public ByteBuffer portNameInByteBuffer(ByteBuffer _bb) { return __vector_in_bytebuffer(_bb, 4, 1); }
  public byte direction() { int o = __offset(6); return o != 0 ? bb.get(o + bb_pos) : 0; }
  public String typeInfo() { int o = __offset(8); return o != 0 ? __string(o + bb_pos) : null; }
  public ByteBuffer typeInfoAsByteBuffer() { return __vector_as_bytebuffer(8, 1); }
  public ByteBuffer typeInfoInByteBuffer(ByteBuffer _bb) { return __vector_in_bytebuffer(_bb, 8, 1); }
  public String description() { int o = __offset(10); return o != 0 ? __string(o + bb_pos) : null; }
  public ByteBuffer descriptionAsByteBuffer() { return __vector_as_bytebuffer(10, 1); }
  public ByteBuffer descriptionInByteBuffer(ByteBuffer _bb) { return __vector_in_bytebuffer(_bb, 10, 1); }

  public static int createPortModel(FlatBufferBuilder builder,
      int port_nameOffset,
      byte direction,
      int type_infoOffset,
      int descriptionOffset) {
    builder.startTable(4);
    PortModel.addDescription(builder, descriptionOffset);
    PortModel.addTypeInfo(builder, type_infoOffset);
    PortModel.addPortName(builder, port_nameOffset);
    PortModel.addDirection(builder, direction);
    return PortModel.endPortModel(builder);
  }

  public static void startPortModel(FlatBufferBuilder builder) { builder.startTable(4); }
  public static void addPortName(FlatBufferBuilder builder, int portNameOffset) { builder.addOffset(0, portNameOffset, 0); }
  public static void addDirection(FlatBufferBuilder builder, byte direction) { builder.addByte(1, direction, 0); }
  public static void addTypeInfo(FlatBufferBuilder builder, int typeInfoOffset) { builder.addOffset(2, typeInfoOffset, 0); }
  public static void addDescription(FlatBufferBuilder builder, int descriptionOffset) { builder.addOffset(3, descriptionOffset, 0); }
  public static int endPortModel(FlatBufferBuilder builder) {
    int o = builder.endTable();
    return o;
  }

  public static final class Vector extends BaseVector {
    public Vector __assign(int _vector, int _element_size, ByteBuffer _bb) { __reset(_vector, _element_size, _bb); return this; }

    public PortModel get(int j) { return get(new PortModel(), j); }
    public PortModel get(PortModel obj, int j) {  return obj.__assign(__indirect(__element(j), bb), bb); }
  }
}

